﻿using Abide.UI_Elements;
using Abide_AddOn_API.Classes;
using System;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;

namespace Abide
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
        }
        
        void LoadRecentMaps()
        {
            //Prepare
            MenuItem RecentMap = null;
            this.FileSeparator1.Visible = false;

            //Re-add...
            this.RecentCEMaps.MenuItems.Clear();
            this.RecentCEMaps.MenuItems.Add(ClearCEMaps);
            this.RecentCEMaps.MenuItems.Add(menuItem1);
            this.RecentH2Maps.MenuItems.Clear();
            this.RecentH2Maps.MenuItems.Add(ClearH2Maps);
            this.RecentH2Maps.MenuItems.Add(menuItem2);
            this.RecentH2BMaps.MenuItems.Clear();
            this.RecentH2BMaps.MenuItems.Add(ClearH2BMaps);
            this.RecentH2BMaps.MenuItems.Add( menuItem3);
            this.RecentH3Maps.MenuItems.Clear();
            this.RecentH3Maps.MenuItems.Add(ClearH3Maps);
            this.RecentH3Maps.MenuItems.Add(menuItem4);
            this.RecentH3BetaMaps.MenuItems.Clear();
            this.RecentH3BetaMaps.MenuItems.Add(ClearH3BMaps);
            this.RecentH3BetaMaps.MenuItems.Add(menuItem5);
            this.RecentHRMaps.MenuItems.Clear();
            this.RecentHRMaps.MenuItems.Add(ClearHRMaps);
            this.RecentHRMaps.MenuItems.Add(menuItem6);

            //Load
            #region Halo CE Maps
            this.RecentCEMaps.Enabled = false;
            this.RecentCEMaps.Visible = false;
            for (int i = 0; i < Settings.RecentMaps_CE.Count; i++)
            {
                //Check if it's not null or blank...
                if (string.IsNullOrEmpty(Settings.RecentMaps_CE[i]))
                    continue;

                //Check to make sure it exists...
                if (!System.IO.File.Exists(Settings.RecentMaps_CE[i]))
                    continue;

                //Set Path
                string Path = Settings.RecentMaps_CE[i];

                //Add Menu Item
                RecentMap = new MenuItem(string.Format("&{0}: {1}", i.ToString(), Path));
                RecentMap.Tag = Settings.RecentMaps_CE[i];
                RecentMap.Click += new EventHandler(RecentMap_Click);
                this.RecentCEMaps.MenuItems.Add(RecentMap);
                this.RecentCEMaps.Enabled = true;
                this.RecentCEMaps.Visible = true;
                this.FileSeparator1.Visible = true;
            }
            #endregion
            #region Halo 2 Maps
            this.RecentH2Maps.Enabled = false;
            this.RecentH2Maps.Visible = false;
            for (int i = 0; i < Settings.RecentMaps_H2.Count; i++)
            {
                //Check if it's not null or blank...
                if (string.IsNullOrEmpty(Settings.RecentMaps_H2[i]))
                    continue;

                //Check to make sure it exists...
                if (!System.IO.File.Exists(Settings.RecentMaps_H2[i]))
                    continue;

                //Set Path
                string Path = Settings.RecentMaps_H2[i];

                //Add Menu Item
                RecentMap = new MenuItem(string.Format("&{0}: {1}", i.ToString(), Path));
                RecentMap.Tag = Settings.RecentMaps_H2[i];
                RecentMap.Click += new EventHandler(RecentMap_Click);
                this.RecentH2Maps.MenuItems.Add(RecentMap);
                this.RecentH2Maps.Enabled = true;
                this.RecentH2Maps.Visible = true;
                this.FileSeparator1.Visible = true;
            }
            #endregion
            #region Halo 2 Beta Maps
            this.RecentH2BMaps.Enabled = false;
            this.RecentH2BMaps.Visible = false;
            for (int i = 0; i < Settings.RecentMaps_H2B.Count; i++)
            {
                //Check if it's not null or blank...
                if (string.IsNullOrEmpty(Settings.RecentMaps_H2B[i]))
                    continue;

                //Check to make sure it exists...
                if (!System.IO.File.Exists(Settings.RecentMaps_H2B[i]))
                    continue;

                //Set Path
                string Path = Settings.RecentMaps_H2B[i];

                //Add Menu Item
                RecentMap = new MenuItem(string.Format("&{0}: {1}", i.ToString(), Path));
                RecentMap.Tag = Settings.RecentMaps_H2B[i];
                RecentMap.Click += new EventHandler(RecentMap_Click);
                this.RecentH2BMaps.MenuItems.Add(RecentMap);
                this.RecentH2BMaps.Enabled = true;
                this.RecentH2BMaps.Visible = true;
                this.FileSeparator1.Visible = true;
            }
            #endregion
            #region Halo 3 Maps
            this.RecentH3Maps.Enabled = false;
            this.RecentH3Maps.Visible = false;
            for (int i = 0; i < Settings.RecentMaps_H3.Count; i++)
            {
                //Check if it's not null or blank...
                if (string.IsNullOrEmpty(Settings.RecentMaps_H3[i]))
                    continue;

                //Check to make sure it exists...
                if (!System.IO.File.Exists(Settings.RecentMaps_H3[i]))
                    continue;

                //Set Path
                string Path = Settings.RecentMaps_H3[i];

                //Add Menu Item
                RecentMap = new MenuItem(string.Format("&{0}: {1}", i.ToString(), Path));
                RecentMap.Tag = Settings.RecentMaps_H3[i];
                RecentMap.Click += new EventHandler(RecentMap_Click);
                this.RecentH3Maps.MenuItems.Add(RecentMap);
                this.RecentH3Maps.Enabled = true;
                this.RecentH3Maps.Visible = true;
                this.FileSeparator1.Visible = true;
            }
            #endregion
            #region Halo 3 Beta Maps
            this.RecentH3BetaMaps.Enabled = false;
            this.RecentH3BetaMaps.Visible = false;
            for (int i = 0; i < Settings.RecentMaps_H3B.Count; i++)
            {
                //Check if it's not null or blank...
                if (string.IsNullOrEmpty(Settings.RecentMaps_H3B[i]))
                    continue;

                //Check to make sure it exists...
                if (!System.IO.File.Exists(Settings.RecentMaps_H3B[i]))
                    continue;

                //Set Path
                string Path = Settings.RecentMaps_H3B[i];

                //Add Menu Item
                RecentMap = new MenuItem(string.Format("&{0}: {1}", i.ToString(), Path));
                RecentMap.Tag = Settings.RecentMaps_H3B[i];
                RecentMap.Click += new EventHandler(RecentMap_Click);
                this.RecentH3BetaMaps.MenuItems.Add(RecentMap);
                this.RecentH3BetaMaps.Enabled = true;
                this.RecentH3BetaMaps.Visible = true;
                this.FileSeparator1.Visible = true;
            }
            #endregion
            #region Halo Reach Maps
            this.RecentHRMaps.Enabled = false;
            this.RecentHRMaps.Visible = false;
            for (int i = 0; i < Settings.RecentMaps_HR.Count; i++)
            {
                //Check if it's not null or blank...
                if (string.IsNullOrEmpty(Settings.RecentMaps_HR[i]))
                    continue;

                //Check to make sure it exists...
                if (!System.IO.File.Exists(Settings.RecentMaps_HR[i]))
                    continue;

                //Set Path
                string Path = Settings.RecentMaps_HR[i];

                //Add Menu Item
                RecentMap = new MenuItem(string.Format("&{0}: {1}", i.ToString(), Path));
                RecentMap.Tag = Settings.RecentMaps_HR[i];
                RecentMap.Click += new EventHandler(RecentMap_Click);
                this.RecentHRMaps.MenuItems.Add(RecentMap);
                this.RecentHRMaps.Enabled = true;
                this.RecentHRMaps.Visible = true;
                this.FileSeparator1.Visible = true;
            }
            #endregion
        }
        void Item_Click(object sender, EventArgs e)
        {
            throw new NotImplementedException();
        }
        void RecentMap_Click(object sender, EventArgs e)
        {
            MenuItem Sender = sender as MenuItem;

            if (Sender != null)
            {
                //Load Map...
                LoadMap(Sender.Tag as string);
            }
        }

        private void Main_Load(object sender, EventArgs e)
        {
            LoadRecentMaps();
        }
        private void OpenItem_Click(object sender, EventArgs e)
        {
            using (FileDialog OpenDlg = new OpenFileDialog())
            {
                OpenDlg.Title = "Select Halo 2 Map to Load...";
                OpenDlg.Filter = "Halo 2 Maps (*.map)|*.map";

                if (OpenDlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    //Load...
                    LoadMap(OpenDlg.FileName);
                }
            }
        }
        private void LoadMap(string FileLocation)
        {
            if (System.IO.File.Exists(FileLocation))
            {
                //Disable...
                this.Enabled = false;

                //Allow all operations to finish...
                System.Threading.Thread.Sleep(0);

                //Create TabPage
                Form MapForm = new Form();
                MapForm.Size = new System.Drawing.Size(720, 480);
                MapForm.MdiParent = this;
                MapForm.Icon = Properties.Resources.Unknown_Map;

                //Prepare Variables
                List<string> RecentMaps;
                Control MC;

                //Get Version
                switch (MapHelper.GetVersion(FileLocation))
                {
                    case Abide_AddOn_API.MapVersion.Halo_2:
                        //Add To Recent Maps
                        RecentMaps = Settings.RecentMaps_H2;
                        RecentMaps.Remove(FileLocation);
                        RecentMaps.Insert(0, FileLocation);
                        Settings.RecentMaps_H2 = RecentMaps;

                        //Create MapControl...
                        MC = new Halo2MapControl(FileLocation);
                        MC.Dock = DockStyle.Fill;
                        MapForm.Controls.Add(MC);

                        //Rename...
                        MapForm.Text = ((Halo2MapControl)MC).Map.MapName;
                        break;

                    case Abide_AddOn_API.MapVersion.Halo_2b:
                        //Add To Recent Maps
                        RecentMaps = Settings.RecentMaps_H2B;
                        RecentMaps.Remove(FileLocation);
                        RecentMaps.Insert(0, FileLocation);
                        Settings.RecentMaps_H2B = RecentMaps;

                        //Create MapControl...
                        MC = new Halo2BetaMapControl(FileLocation);
                        MC.Dock = DockStyle.Fill;
                        MapForm.Controls.Add(MC);

                        //Rename...
                        MapForm.Text = ((Halo2BetaMapControl)MC).Map.MapName;
                        break;
                }

                //Rename...
                MapForm.WindowState = FormWindowState.Maximized;

                //Add Form
                MapForm.Show();

                //Enable
                this.Enabled = true;
                this.Focus();

                //Handle recent Maps
                LoadRecentMaps();
            }
        }
        private void OptionsItem_Click(object sender, EventArgs e)
        {
            //Show Options...
            using (Forms.OptionsForm OptDlg = new Forms.OptionsForm(this))
            {
                OptDlg.ShowDialog();
            }
        }
        private void ExitItem_Click(object sender, EventArgs e)
        {
            //Exit...
            Application.Exit();
        }
        private void XboxItem_Click(object sender, EventArgs e)
        {
            //Prepare Tab and Control
            Form XboxForm = new Form();
            XboxForm.Icon = Properties.Resources.Xbox;
            XboxForm.Text = "Xbox";
            XboxForm.Size = new System.Drawing.Size(720, 480);
            XboxControl XboxCtrl = new XboxControl();
            XboxCtrl.Dock = DockStyle.Fill;
            XboxForm.Controls.Add(XboxCtrl);

            //Add Form
            XboxForm.MdiParent = this;
            XboxForm.Show();
        }
        private void TileVertItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileVertical);
        }
        private void TileHorItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileHorizontal);
        }
        private void CascadeItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.Cascade);
        }
        private void ClearCEMaps_Click(object sender, EventArgs e)
        {
            Settings.RecentMaps_CE = new List<string>(); LoadRecentMaps();
        }
        private void ClearH2Maps_Click(object sender, EventArgs e)
        {
            Settings.RecentMaps_H2 = new List<string>(); LoadRecentMaps();
        }
        private void ClearH2BMaps_Click(object sender, EventArgs e)
        {
            Settings.RecentMaps_H2B = new List<string>(); LoadRecentMaps();
        }
        private void ClearH3Maps_Click(object sender, EventArgs e)
        {
            Settings.RecentMaps_H3 = new List<string>(); LoadRecentMaps();
        }
        private void ClearH3BetaMaps_Click(object sender, EventArgs e)
        {
            Settings.RecentMaps_H3B = new List<string>(); LoadRecentMaps();
        }
        private void ClearHRMaps_Click(object sender, EventArgs e)
        {
            Settings.RecentMaps_HR = new List<string>(); LoadRecentMaps();
        }
        private void CodePlexItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("http://abide.codeplex.com/");
        }
        private void RemnantItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("http://remnantmods.com/forums");
        }
        private void BugItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("https://abide.codeplex.com/workitem/list/basic");
        }
        private void CommentItem_Click(object sender, EventArgs e)
        {
            System.Diagnostics.Process.Start("https://abide.codeplex.com/discussions");
        }
    }
}
