﻿using Abide_AddOn_API;
using Abide_AddOn_API.Classes;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Windows.Forms;

namespace Abide
{
    static class Program
    {
        public static event XboxChangedEventHandler XboxChanged;

        /// <summary>
        /// Add garbage to here...
        /// </summary>
        public static List<IDisposable> Garbage = new List<IDisposable>();

        /// <summary>
        /// Global Xbox Reference
        /// </summary>
        public static DebugXbox Xbox
        {
            get;
            set;
        }

        public static Classes.Theme_Manager ThemeManager
        {
            get { return _themeManager; }
        }

        static Classes.Theme_Manager _themeManager;

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            //LoadXboxs
            Xbox = DebugXbox.CreateXbox();

            //Initialize...
            Settings.CreateKeys();

            //Prepare...
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            //Load Themes
            LoadThemes();
            
            //Check Settings and Desktop Composition
            switch (Settings.Theme)
            {
                case "Default":
                    Application.Run(new Main());
                    break;

                default:
                    Form result = new Main();

                    foreach (ITheme Theme in ThemeManager.Themes)
                    {
                        if (Theme.Name == Settings.Theme)
                        {
                            Theme.Initialize();
                            result = Theme.MainForm;
                        }
                    }

                    Application.Run(result);
                    break;
            }
        }
        static void LoadThemes()
        {
            //Initialize
            _themeManager = new Classes.Theme_Manager();

            string ThemesPath = Settings.ThemesPath;

            //Check Themes folder..
            if (!Directory.Exists(ThemesPath))
                Directory.CreateDirectory(ThemesPath);

            try
            {
                //Get AddOn Folders...
                string[] ThemesFolder = Directory.GetDirectories(ThemesPath);

                //Loop...
                foreach (string Folder in ThemesFolder)
                {
                    string[] Files = Directory.GetFiles(Folder);

                    foreach (string File in Files)
                    {
                        //Add (possible) AddOns.
                        _themeManager.AddThemes(File);
                    }
                }
            }
            catch(Exception ex)
            {
                Console.WriteLine(ex.StackTrace);
            }
        }
        public static void Cleanup()
        {
            foreach (IDisposable obj in Garbage)
            {
                obj.Dispose();
            }
        }
        public static void ChangeXbox(object sender)
        {
            if (XboxChanged != null)
                XboxChanged(sender, new XboxChangedEventArgs(Xbox));
        }
    }
}
