﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AbideHaloLibrary.Classes
{
    public static class BitHelper
    {
        public static bool[] GetBits(byte value)
        {
            //Create Bits...
            bool[] Bits = new bool[8];

            //Get Bits...
            ulong NewValue = value;
            for (int i = 0; i < 8; i++)
            {
                //Do Math...
                if (NewValue % 2 == 0)
                {
                    Bits[i] = false;
                }
                else
                {
                    Bits[i] = true;
                }

                //Half...
                NewValue /= 2;
            }

            //Return...
            return Bits;
        }
        public static bool[] GetBits(ushort value)
        {
            //Create Bits...
            bool[] Bits = new bool[16];

            //Get Bits...
            ulong NewValue = value;
            for (int i = 0; i < 16; i++)
            {
                //Do Math...
                if (NewValue % 2 == 0)
                {
                    Bits[i] = false;
                }
                else
                {
                    Bits[i] = true;
                }

                //Half...
                NewValue /= 2;
            }

            //Return...
            return Bits;
        }
        public static bool[] GetBits(uint value)
        {
            //Create Bits...
            bool[] Bits = new bool[32];

            //Get Bits...
            ulong NewValue = value;
            for (int i = 0; i < 32; i++)
            {
                //Do Math...
                if (NewValue % 2 == 0)
                {
                    Bits[i] = false;
                }
                else
                {
                    Bits[i] = true;
                }

                //Half...
                NewValue /= 2;
            }

            //Return...
            return Bits;
        }
        public static bool[] GetBits(ulong value)
        {
            //Create Bits...
            bool[] Bits = new bool[64];

            //Get Bits...
            ulong NewValue = value;
            for (int i = 0; i < 64; i++)
            {
                //Do Math...
                if (NewValue % 2 == 0)
                {
                    Bits[i] = false;
                }
                else
                {
                    Bits[i] = true;
                }

                //Half...
                NewValue /= 2;
            }

            //Return...
            return Bits;
        }

        public static byte GetByte(bool[] BitValues)
        {
            //Get Proper Bits...
            bool[] Bits = new bool[8];
            Array.Copy(BitValues, Bits, BitValues.Length);

            //Create Return Type...
            byte ReturnValue = 0;

            //Loop...
            for (int i = 7; i >= 0; i--)
            {
                if (Bits[i] == true)
                    ReturnValue += (byte)Math.Pow(2, i);
            }

            //Return...
            return ReturnValue;
        }
        public static ushort GetUShort(bool[] BitValues)
        {
            //Get Proper Bits...
            bool[] Bits = new bool[16];
            Array.Copy(BitValues, Bits, BitValues.Length);

            //Create Return Type...
            ushort ReturnValue = 0;

            //Loop...
            for (int i = 15; i >= 0; i--)
            {
                if (Bits[i] == true)
                    ReturnValue += (ushort)Math.Pow(2, i);
            }

            //Return...
            return ReturnValue;
        }
        public static uint GetUInt(bool[] BitValues)
        {
            //Get Proper Bits...
            bool[] Bits = new bool[32];
            Array.Copy(BitValues, Bits, BitValues.Length);

            //Create Return Type...
            uint ReturnValue = 0;

            //Loop...
            for (int i = 31; i >= 0; i--)
            {
                if (Bits[i] == true)
                    ReturnValue += (uint)Math.Pow(2, i);
            }

            //Return...
            return ReturnValue;
        }
        public static ulong GetULong(bool[] BitValues)
        {
            //Get Proper Bits...
            bool[] Bits = new bool[64];
            Array.Copy(BitValues, Bits, BitValues.Length);

            //Create Return Type...
            ulong ReturnValue = 0;

            //Loop...
            for (int i = 63; i >= 0; i--)
            {
                if (Bits[i] == true)
                    ReturnValue += (ulong)Math.Pow(2, i);
            }

            //Return...
            return ReturnValue;
        }

        public static string GetBitString(bool[] Bits)
        {
            //Create...
            string String = string.Empty;
            int bitLocation = 0;

            //Loop
            for (int i = 0; i < Bits.Length; i++)
            {
                //Check if needed separation...
                if (bitLocation == 4)
                {
                    bitLocation = 0;
                    String += " ";
                }

                //Set...
                String += Bits[i] == true ? "1" : "0";
                bitLocation++;
            }

            //Return
            return String;
        }
    }
}
