﻿using AbideHaloLibrary.Map;
using System.Collections;

namespace AbideHaloLibrary.Halo_2_Map
{
    public class Header
    {
        #region Properties
        public int Version
        {
            get { return version; }
        }
        public int FileSize
        {
            get { return fileSize; }
        }
        public int IndexOffset
        {
            get { return indexOffset; }
        }
        public int IndexSize
        {
            get { return indexSize; }
        }
        public int MetaSize
        {
            get { return metaSize; }
        }
        public int NonRawSize
        {
            get { return nonRawSize; }
        }
        public string Origin
        {
            get
            {
                string ret = string.Empty;

                for (int i = 0; i < mapOrigin.Length; i++)
                {
                    if (mapOrigin[i] != '\0')
                        ret += mapOrigin[i];
                }

                return ret;
            }
        }
        public string Build
        {
            get
            {
                string ret = string.Empty;

                for (int i = 0; i < build.Length; i++)
                {
                    if (build[i] != '\0')
                        ret += build[i];
                }

                return ret;
            }
        }
        public int Crazy
        {
            get { return crazyOffset; }
        }
        public int CrazySize
        {
            get { return crazySize; }
        }
        public int Strings128TableOffset
        {
            get { return strings128TableOffset; }
        }
        public int StringsCount
        {
            get { return stringsCount; }
        }
        public int StringTableSize
        {
            get { return stringTableSize; }
        }
        public int StringTableIndexOffset
        {
            get { return stringTableIndexOffset; }
        }
        public int StringTableOffset
        {
            get { return stringTableOffset; }
        }
        public string MapName
        {
            get
            {
                string ret = string.Empty;

                for (int i = 0; i < mapName.Length; i++)
                {
                    if (mapName[i] != '\0')
                        ret += mapName[i];
                }

                return ret;
            }
        }
        public string ScenarioPath
        {
            get
            {
                string ret = string.Empty;

                for (int i = 0; i < scenarioPath.Length; i++)
                {
                    if (scenarioPath[i] != '\0')
                        ret += scenarioPath[i];
                }

                return ret;
            }
        }
        public int FileCount
        {
            get { return fileCount; }
        }
        public int FileTableSize
        {
            get { return fileTableSize; }
        }
        public int FileTableOffset
        {
            get { return fileTableOffset; }
        }
        public int FilesIndexOffset
        {
            get { return filesIndex; }
        }
        public int Signature
        {
            get { return signature; }
        }
        #endregion
        #region Fields
        char[] head = new char[4]; //0
        int version; //4
        int fileSize; //8
        int zero_1; //12
        int indexOffset; //16
        int indexSize; //20
        int metaSize; //24
        int nonRawSize; //28
        char[] mapOrigin = new char[32];
        byte[] unknown_2 = new byte[224];
        char[] build = new char[32];
        byte[] unknown_3 = new byte[20];
        int unknown_4;
        int crazyOffset;
        int crazySize;
        int strings128TableOffset;
        int stringsCount;
        int stringTableSize;
        int stringTableIndexOffset;
        int stringTableOffset;
        byte[] unknown_6 = new byte[36];
        char[] mapName = new char[32];
        int zero_2;
        char[] scenarioPath = new char[32];
        byte[] zero_3 = new byte[224];
        int unknown_7;
        int fileCount;
        int fileTableOffset;
        int fileTableSize;
        int filesIndex;
        int signature;
        byte[] zero_4 = new byte[1320];
        char[] foot = new char[4];
        #endregion
        #region Methods
        public Header(HaloIO IO)
        {
            //Read Data...
            IO.MapStream.Position = 0L;
            head = IO.In.ReadChars(4);
            version = IO.In.ReadInt32();
            fileSize = IO.In.ReadInt32();
            zero_1 = IO.In.ReadInt32();
            indexOffset = IO.In.ReadInt32();
            indexSize = IO.In.ReadInt32();
            metaSize = IO.In.ReadInt32();
            nonRawSize = IO.In.ReadInt32();
            mapOrigin = IO.In.ReadChars(32);
            unknown_2 = IO.In.ReadBytes(224);
            build = IO.In.ReadChars(32);
            unknown_3 = IO.In.ReadBytes(20);
            unknown_4 = IO.In.ReadInt32();
            crazyOffset = IO.In.ReadInt32();
            crazySize = IO.In.ReadInt32();
            strings128TableOffset = IO.In.ReadInt32();
            stringsCount = IO.In.ReadInt32();
            stringTableSize = IO.In.ReadInt32();
            stringTableIndexOffset = IO.In.ReadInt32();
            stringTableOffset = IO.In.ReadInt32();
            unknown_6 = IO.In.ReadBytes(36);
            mapName = IO.In.ReadChars(32);
            zero_2 = IO.In.ReadInt32();
            scenarioPath = IO.In.ReadChars(32);
            zero_3 = IO.In.ReadBytes(224);
            unknown_7 = IO.In.ReadInt32();
            fileCount = IO.In.ReadInt32();
            fileTableOffset = IO.In.ReadInt32();
            fileTableSize = IO.In.ReadInt32();
            filesIndex = IO.In.ReadInt32();
            signature = IO.In.ReadInt32();
            zero_4 = IO.In.ReadBytes(1064);
            foot = IO.In.ReadChars(4);
        }
        public override string ToString()
        {
            return string.Format("{0}", MapName);
        }
        #endregion
    }
}
