﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using System.Windows.Forms.Design;

namespace Potential_Software.Potential_UI.Forms
{
    [Designer(typeof(PotentialCrumbBarDesigner))]
    public class PotentialCrumbBar : Control
    {
        public CrumbBarItemCollection Items
        {
            get { return mItems; }
            set { mItems = value; }
        }

        private int mHeight = 23;
        private float mCrumbMargin = 0.75f;
        private CrumbBarItemCollection mItems = new CrumbBarItemCollection();

        protected override void SetBoundsCore(int x, int y, int width, int height, BoundsSpecified specified)
        {
            height = mHeight;
            base.SetBoundsCore(x, y, width, height, specified);
        }

        public PotentialCrumbBar()
        {
        }

        public class CrumbBarItemCollection : IList, ICollection, IEnumerable
        {
            ArrayList InnerList;
            private event EventHandler itemChanged;

            public event EventHandler ItemChanged
            {
                add { itemChanged += value; }
                remove { itemChanged -= value; }
            }

            protected virtual void OnItemChanged(EventArgs e)
            {
                itemChanged(this, e);
            }

            public CrumbBarItemCollection()
            {
                this.InnerList = new ArrayList(new List<CrumbBarItem>());
            }
            public int Add(CrumbBarItem value)
            {
                return InnerList.Add(value);
            }
            int IList.Add(object value)
            {
                return InnerList.Add(value);
            }
            public void Clear()
            {
                InnerList.Clear();
            }
            void IList.Clear()
            {
                InnerList.Clear();
            }
            public bool Contains(CrumbBarItem value)
            {
                return InnerList.Contains(value);
            }
            bool IList.Contains(object value)
            {
                return InnerList.Contains(value);
            }
            public int IndexOf(CrumbBarItem value)
            {
                return InnerList.IndexOf(value);
            }
            int IList.IndexOf(object value)
            {
                return InnerList.IndexOf(value);
            }
            public void Insert(int index, CrumbBarItem value)
            {
                InnerList.Insert(index, value);
            }
            void IList.Insert(int index, object value)
            {
                InnerList.Insert(index, value);
            }
            public bool IsFixedSize
            {
                get { return false; }
            }
            bool IList.IsFixedSize
            {
                get { return InnerList.IsFixedSize; }
            }
            public bool IsReadOnly
            {
                get { return false; }
            }
            public void Remove(CrumbBarItem value)
            {
                InnerList.Remove(value);
            }
            public void RemoveAt(int index)
            {
                InnerList.RemoveAt(index);
            }
            public CrumbBarItem this[int Index]
            {
                get { return InnerList[Index] as CrumbBarItem; }
                set { InnerList[Index] = value; }
            }
            public void CopyTo(Array array, int index)
            {
                InnerList.CopyTo(array, index);
            }
            public int Count
            {
                get { return InnerList.Count; }
            }
            public bool IsSynchronized
            {
                get { return InnerList.IsSynchronized; }
            }
            public object SyncRoot
            {
                get { return InnerList.SyncRoot; }
            }
            public IEnumerator GetEnumerator()
            {
                return InnerList.GetEnumerator();
            }
            bool IList.IsReadOnly
            {
                get { throw new NotImplementedException(); }
            }
            void IList.Remove(object value)
            {
                throw new NotImplementedException();
            }
            void IList.RemoveAt(int index)
            {
                throw new NotImplementedException();
            }
            object IList.this[int index]
            {
                get
                {
                    throw new NotImplementedException();
                }
                set
                {
                    throw new NotImplementedException();
                }
            }
            void ICollection.CopyTo(Array array, int index)
            {
                throw new NotImplementedException();
            }
            int ICollection.Count
            {
                get { throw new NotImplementedException(); }
            }
            bool ICollection.IsSynchronized
            {
                get { throw new NotImplementedException(); }
            }
            object ICollection.SyncRoot
            {
                get { throw new NotImplementedException(); }
            }
            IEnumerator IEnumerable.GetEnumerator()
            {
                throw new NotImplementedException();
            }
        }
    }

    public class CrumbBarItem
    {
        private string text;
        private int selectedIndex;
        private PotentialCrumbBar.CrumbBarItemCollection items;
        private Image icon;

        /// <summary>
        /// Returns the Text of the Control
        /// </summary>
        public string Text
        {
            get { return text; }
            set { text = value; }
        }
        /// <summary>
        /// 
        /// </summary>
        public int SelectedIndex
        {
            get { return selectedIndex; }
        }
        /// <summary>
        /// 
        /// </summary>
        public PotentialCrumbBar.CrumbBarItemCollection Children
        {
            get { return items; }
        }
        /// <summary>
        /// 
        /// </summary>
        public Image Icon
        {
            get { return icon; }
            set { if (icon != null) { icon.Dispose(); } icon = value; }
        }
    }

    internal class PotentialCrumbBarDesigner : ControlDesigner
    {
        PotentialCrumbBarDesigner()
        {
            base.AutoResizeHandles = true;
        }

        public override SelectionRules SelectionRules
        {
            get
            {
                return SelectionRules.LeftSizeable | SelectionRules.RightSizeable | SelectionRules.Moveable;
            }
        }
    }
}
